/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.foundation.ProgressMonitor"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.repository.web.foundation.ProgressMonitor", null, { //$NON-NLS-1$

	_cancelRequested: false,

	constructor: function(notifyBeginTask, notifyDone, notifyCancelRequest) {
		this._notifyBeginTask= notifyBeginTask;
		this._notifyDone= notifyDone;
		this._notifyCancelRequest= notifyCancelRequest;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	beginTask: function(name) {
		if (dojo.isFunction(this._notifyBeginTask)) {
			this._notifyBeginTask(name);
		}
	},

	done: function() {
		if (dojo.isFunction(this._notifyDone)) {
			this._notifyDone();
		}
	},

	setCancelled: function() {
		if (!this._cancelRequested) {
			this._cancelRequested= true;
			if (dojo.isFunction(this._notifyCancelRequest)) {
				this._notifyCancelRequest();
			}
		}
	},

	isCancelRequested: function() {
		return this._cancelRequested;
	},

	__sentinel: null // terminates this class definition
});

})();
